

public class SynchronizedMultithread extends Thread {

	SharedCounter counter; // global counter (shared resource among multithreads)

	public SynchronizedMultithread(String name, SharedCounter cnt, int priority) {
		super(name);
		counter = cnt;
		setPriority(priority);
	}
	
	@Override
	public void run() { // Thread run() method override
		int i = 0; // local counter
		while (i<10) {
			//System.out.println("Current Thread~~~~~~~~ " + Thread.currentThread().getName() + " " + Thread.currentThread().getId() + " " + Thread.currentThread().getPriority() + " " + Thread.currentThread().getState());

			counter.nextCount(i); // global counter
			i++; // local counter
			
			try {
				sleep(1000);
			} catch (InterruptedException e) {
				return;
			}
		}
	}
}
