
public class SynchronizedMultithreadRunnable implements Runnable {

	SharedCounter counter; // global counter (shared resource among multithreads)

	public SynchronizedMultithreadRunnable(SharedCounter cnt) {
		counter = cnt;
	}

	@Override
	public void run() { // Runnable run() implement
		int i = 0; // local counter
		while (i<10) {

			counter.nextCount(i); // global counter
			i++; // local counter

			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				return;
			}
		}
	}
}
